Index: branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 367)
+++ branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 440)
@@ -4859,25 +5261,23 @@
         if(m_monitor_ok)
         {
-          vci_addr_t address = m_cmd_cas_addr_fifo.read();
+          addr_t address = m_cmd_cas_addr_fifo.read();
           char buf[80];
-          snprintf(buf, 80, "CAS_DIR_HIT_WRITE srcid %d", m_cmd_cas_srcid_fifo.read());
-          check_monitor(buf, address, r_cas_wdata.read());
+          snprintf(buf, 80, "CAS_DIR_HIT_WRITE srcid %d",
+                   (int)m_cmd_cas_srcid_fifo.read());
+          check_monitor(buf, address, r_cas_wdata.read(), false);
 
           if(r_cas_cpt.read() == 4)
-            check_monitor(buf, address+4, m_cmd_cas_wdata_fifo.read());
+            check_monitor(buf, address+4, m_cmd_cas_wdata_fifo.read(), false);
         }
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".CAS_DIR_HIT_WRITE> Update cache:"
-                    << " way = " << std::dec << way
-                    << " / set = " << set
-                    << " / word = " << word
-                    << " / value = " << r_cas_wdata.read()
-                    << " / count = " << r_cas_count.read() << std::endl;
-          std::cout << "  <MEMC "
-                    << name() << ".CAS_DIR_HIT_WRITE> global_llsc_table SW access" << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_DIR_HIT_WRITE> Update cache:"
+          << " way = " << std::dec << way
+          << " / set = " << set
+          << " / word = " << word
+          << " / value = " << r_cas_wdata.read()
+          << " / count = " << r_cas_count.read()
+          << " / global_llsc_table access" << std::endl;
 #endif
       }
@@ -4896,22 +5296,23 @@
         size_t      trdid      = m_cmd_cas_trdid_fifo.read();
         size_t      pktid      = m_cmd_cas_pktid_fifo.read();
-        addr_t      nline      = m_nline[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
+        addr_t      nline      = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
         size_t      nb_copies  = r_cas_count.read();
 
-        wok = m_upt.set(true,  // it's an update transaction
-                               false,   // it's not a broadcast
-                               true,    // it needs a response
-                               srcid,
-                               trdid,
-                               pktid,
-                               nline,
-                               nb_copies,
-                               index);
+        wok = m_upt.set(true,    // it's an update transaction
+                        false,   // it's not a broadcast
+                        true,    // response required  
+                        false,   // no acknowledge required
+                        srcid,
+                        trdid,
+                        pktid,
+                        nline,
+                        nb_copies,
+                        index);
         if(wok)   // coherence transaction registered in UPT
         {
           // cache update
           size_t way  = r_cas_way.read();
-          size_t set  = m_y[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
-          size_t word = m_x[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
+          size_t set  = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
+          size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
 
           m_cache_data.write(way, set, word, r_cas_wdata.read());
@@ -4925,11 +5326,12 @@
           if(m_monitor_ok)
           {
-            vci_addr_t address = m_cmd_cas_addr_fifo.read();
+            addr_t address = m_cmd_cas_addr_fifo.read();
             char buf[80];
-            snprintf(buf, 80, "CAS_DIR_HIT_WRITE srcid %d", m_cmd_cas_srcid_fifo.read());
-            check_monitor(buf, address, r_cas_wdata.read());
+            snprintf(buf, 80, "CAS_DIR_HIT_WRITE srcid %d",
+                     (int)m_cmd_cas_srcid_fifo.read());
+            check_monitor(buf, address, r_cas_wdata.read(), false);
 
             if(r_cas_cpt.read() ==4)
-              check_monitor(buf, address+4, m_cmd_cas_wdata_fifo.read());
+              check_monitor(buf, address+4, m_cmd_cas_wdata_fifo.read(), false);
           }
         }
@@ -4940,12 +5342,10 @@
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
-        {
-          std::cout << "  <MEMC " << name()
-                    << ".CAS_UPT_LOCK> Register multi-update transaction in UPT"
-                    << " / wok = " << wok
-                    << " / nline  = " << std::hex << nline
-                    << " / count = " << nb_copies << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CAS_UPT_LOCK> Register multi-update transaction in UPT"
+          << " / wok = " << wok
+          << " / nline  = " << std::hex << nline
+          << " / count = " << nb_copies << std::endl;
 #endif
       }
@@ -4957,8 +5357,8 @@
 
 #if DEBUG_MEMC_CAS
-      if(m_debug_cas_fsm)
+      if(m_debug)
       {
         std::cout << "  <MEMC " << name()
-                  << ".CAS_WAIT> Release all locks" << std::endl;
+                  << " CAS_WAIT> Release all locks" << std::endl;
       }
 #endif
@@ -4973,8 +5373,8 @@
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
+        if(m_debug)
         {
           std::cout << "  <MEMC " << name()
-                    << ".CAS_UPT_HEAP_LOCK> Get access to the heap" << std::endl;
+                    << " CAS_UPT_HEAP_LOCK> Get access to the heap" << std::endl;
         }
 #endif
@@ -4989,10 +5389,10 @@
              "VCI_MEM_CACHE ERROR : bad HEAP allocation");
 
-      if(!r_cas_to_cc_send_multi_req.read() && !r_cas_to_cc_send_brdcast_req.read())
+      if(!r_cas_to_cc_send_multi_req.read() and !r_cas_to_cc_send_brdcast_req.read())
       {
         r_cas_to_cc_send_brdcast_req  = false;
         r_cas_to_cc_send_trdid        = r_cas_upt_index.read();
-        r_cas_to_cc_send_nline        = m_nline[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
-        r_cas_to_cc_send_index        = m_x[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
+        r_cas_to_cc_send_nline        = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
+        r_cas_to_cc_send_index        = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
         r_cas_to_cc_send_wdata        = r_cas_wdata.read();
 
@@ -5029,7 +5429,7 @@
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".CAS_UPT_REQ> Send the first update request to CC_SEND FSM "
+        if(m_debug)
+        {
+          std::cout << "  <MEMC " << name() << " CAS_UPT_REQ> Send the first update request to CC_SEND FSM "
                     << " / address = " << std::hex << m_cmd_cas_addr_fifo.read()
                     << " / wdata = " << std::hex << r_cas_wdata.read()
@@ -5069,7 +5469,7 @@
 
 #if DEBUG_MEMC_CAS
-      if(m_debug_cas_fsm)
-      {
-        std::cout << "  <MEMC " << name() << ".CAS_UPT_NEXT> Send the next update request to CC_SEND FSM "
+      if(m_debug)
+      {
+        std::cout << "  <MEMC " << name() << " CAS_UPT_NEXT> Send the next update request to CC_SEND FSM "
                   << " / address = " << std::hex << m_cmd_cas_addr_fifo.read()
                   << " / wdata = " << std::hex << r_cas_wdata.read()
@@ -5088,5 +5488,5 @@
         {
           // fill the data buffer
-          size_t word = m_x[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
+          size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
           for(size_t i = 0; i<m_words; i++)
           {
@@ -5095,5 +5495,5 @@
               r_cas_to_ixr_cmd_data[i] = r_cas_wdata.read();
             }
-            else if((i == word+1) && (r_cas_cpt.read() == 4))   // 64 bit CAS
+            else if((i == word+1) and (r_cas_cpt.read() == 4))   // 64 bit CAS
             {
               r_cas_to_ixr_cmd_data[i] = m_cmd_cas_wdata_fifo.read();
@@ -5123,7 +5523,7 @@
       break;
     }
-    ///////////////////
+    /////////////////////
     case CAS_BC_UPT_LOCK:  // register a broadcast inval transaction in UPT
-      // write data in cache in case of successful registration
+                           // write data in cache in case of successful registration
     {
       if(r_alloc_upt_fsm.read() == ALLOC_UPT_CAS)
@@ -5134,17 +5534,18 @@
         size_t      trdid     = m_cmd_cas_trdid_fifo.read();
         size_t      pktid     = m_cmd_cas_pktid_fifo.read();
-        addr_t      nline     = m_nline[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
+        addr_t      nline     = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
         size_t      nb_copies = r_cas_count.read();
 
         // register a broadcast inval transaction in UPT
         wok = m_upt.set(false,  // it's an inval transaction
-                               true,    // it's a broadcast
-                               true,    // it needs a response
-                               srcid,
-                               trdid,
-                               pktid,
-                               nline,
-                               nb_copies,
-                               index);
+                        true,    // it's a broadcast
+                        true,    // response required
+                        false,   // no acknowledge required
+                        srcid,
+                        trdid,
+                        pktid,
+                        nline,
+                        nb_copies,
+                        index);
 
         if(wok)     // UPT not full
@@ -5152,6 +5553,6 @@
           // cache update
           size_t way  = r_cas_way.read();
-          size_t set  = m_y[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
-          size_t word = m_x[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
+          size_t set  = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
+          size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
 
           m_cache_data.write(way, set, word, r_cas_wdata.read());
@@ -5162,21 +5563,22 @@
           if(m_monitor_ok)
           {
-            vci_addr_t address = m_cmd_cas_addr_fifo.read();
+            addr_t address = m_cmd_cas_addr_fifo.read();
             char buf[80];
-            snprintf(buf, 80, "CAS_DIR_HIT_WRITE srcid %d", m_cmd_cas_srcid_fifo.read());
-            check_monitor(buf, address, r_cas_wdata.read());
+            snprintf(buf, 80, "CAS_DIR_HIT_WRITE srcid %d",
+                     (int)m_cmd_cas_srcid_fifo.read());
+            check_monitor(buf, address, r_cas_wdata.read(), false);
             if(r_cas_cpt.read() ==4)
-              check_monitor(buf, address+4, m_cmd_cas_wdata_fifo.read());
+              check_monitor(buf, address+4, m_cmd_cas_wdata_fifo.read(), false);
           }
           r_cas_upt_index = index;
           r_cas_fsm = CAS_BC_DIR_INVAL;
+
 #if DEBUG_MEMC_CAS
-          if(m_debug_cas_fsm)
-          {
-            std::cout << "  <MEMC " << name() << ".CAS_BC_UPT_LOCK> Register a broadcast inval transaction in UPT"
-                      << " / nline = " << nline
-                      << " / count = " << nb_copies
-                      << " / upt_index = " << index << std::endl;
-          }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CAS_BC_UPT_LOCK> Register a broadcast inval transaction in UPT"
+          << " / nline = " << std::hex << nline
+          << " / count = " << std::dec << nb_copies
+          << " / upt_index = " << index << std::endl;
 #endif
         }
@@ -5188,9 +5590,9 @@
       break;
     }
-    //////////////////
+    //////////////////////
     case CAS_BC_DIR_INVAL:  // Register the PUT transaction in TRT, and inval the DIR entry
     {
-      if((r_alloc_trt_fsm.read() == ALLOC_TRT_CAS) &&
-          (r_alloc_upt_fsm.read() == ALLOC_UPT_CAS) &&
+      if((r_alloc_trt_fsm.read() == ALLOC_TRT_CAS) and
+          (r_alloc_upt_fsm.read() == ALLOC_UPT_CAS) and
           (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS))
       {
@@ -5198,5 +5600,5 @@
         m_trt.set(r_cas_trt_index.read(),
                               false,    // PUT request to XRAM
-                              m_nline[(vci_addr_t)(m_cmd_cas_addr_fifo.read())],
+                              m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())],
                               0,
                               0,
@@ -5222,5 +5624,5 @@
         entry.owner.inst    = false;
         entry.ptr           = 0;
-        size_t set          = m_y[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
+        size_t set          = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
         size_t way          = r_cas_way.read();
         m_cache_directory.write(set, way, entry);
@@ -5229,10 +5631,9 @@
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".CAS_BC_DIR_INVAL> Register the PUT in TRT and invalidate DIR entry"
-                    << " / nline = " << std::hex << m_nline[(vci_addr_t)(m_cmd_cas_addr_fifo.read())]
-                    << " / set = " << std::dec << set << " / way = " << way << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CAS_BC_DIR_INVAL> Register the PUT in TRT and invalidate DIR entry"
+          << " / nline = " << std::hex << m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())]
+          << " / set = " << std::dec << set << " / way = " << way << std::endl;
 #endif
       }
@@ -5246,5 +5647,5 @@
     case CAS_BC_CC_SEND:  // Request the broadcast inval to CC_SEND FSM
     {
-      if(!r_cas_to_cc_send_multi_req.read() &&
+      if(!r_cas_to_cc_send_multi_req.read() and
           !r_cas_to_cc_send_brdcast_req.read())
       {
@@ -5252,5 +5653,5 @@
         r_cas_to_cc_send_brdcast_req  = true;
         r_cas_to_cc_send_trdid        = r_cas_upt_index.read();
-        r_cas_to_cc_send_nline        = m_nline[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
+        r_cas_to_cc_send_nline        = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
         r_cas_to_cc_send_index        = 0;
         r_cas_to_cc_send_wdata        = 0;
@@ -5267,5 +5668,5 @@
         r_cas_to_ixr_cmd_req     = true;
         r_cas_to_ixr_cmd_write   = true;
-        r_cas_to_ixr_cmd_nline   = m_nline[(vci_addr_t)(m_cmd_cas_addr_fifo.read())];
+        r_cas_to_ixr_cmd_nline   = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
         r_cas_to_ixr_cmd_trdid   = r_cas_trt_index.read();
         r_cas_fsm                = CAS_IDLE;
@@ -5274,16 +5675,15 @@
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".CAS_BC_XRAM_REQ> Request a PUT transaction to IXR_CMD FSM" << std::hex
-                    << " / nline = " << m_nline[(vci_addr_t) m_cmd_cas_addr_fifo.read()]
-                    << " / trt_index = " << r_cas_trt_index.read() << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CAS_BC_XRAM_REQ> Request a PUT transaction to IXR_CMD FSM" << std::hex
+          << " / nline = " << m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]
+          << " / trt_index = " << r_cas_trt_index.read() << std::endl;
 #endif
       }
       else
       {
-        std::cout << "MEM_CACHE, CAS_BC_XRAM_REQ state : request should not have been previously set"
-                  << std::endl;
+        std::cout << "ERROR in MEM_CACHE / CAS_BC_XRAM_REQ state"
+                  << " : request should not have been previously set" << std::endl;
       }
       break;
@@ -5304,8 +5704,7 @@
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".CAS_RSP_FAIL> Request TGT_RSP to send a failure response" << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CAS_RSP_FAIL> Request TGT_RSP to send a failure response" << std::endl;
 #endif
       }
@@ -5327,8 +5726,7 @@
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".CAS_RSP_SUCCESS> Request TGT_RSP to send a success response" << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CAS_RSP_SUCCESS> Request TGT_RSP to send a success response" << std::endl;
 #endif
       }
@@ -5342,13 +5740,13 @@
         size_t   index = 0;
         bool hit_read = m_trt.hit_read(
-                          m_nline[(vci_addr_t) m_cmd_cas_addr_fifo.read()],index);
+                          m_nline[(addr_t) m_cmd_cas_addr_fifo.read()],index);
         bool hit_write = m_trt.hit_write(
-                           m_nline[(vci_addr_t) m_cmd_cas_addr_fifo.read()]);
+                           m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]);
         bool wok = !m_trt.full(index);
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".CAS_MISS_TRT_LOCK> Check TRT state"
+        if(m_debug)
+        {
+          std::cout << "  <MEMC " << name() << " CAS_MISS_TRT_LOCK> Check TRT state"
                     << " / hit_read = "  << hit_read
                     << " / hit_write = " << hit_write
@@ -5358,5 +5756,5 @@
 #endif
 
-        if(hit_read || !wok || hit_write)    // missing line already requested or no space in TRT
+        if(hit_read or !wok or hit_write)    // missing line already requested or no space in TRT
         {
           r_cas_fsm = CAS_WAIT;
@@ -5387,5 +5785,5 @@
         m_trt.set(r_cas_trt_index.read(),
                               true,   // read request
-                              m_nline[(vci_addr_t) m_cmd_cas_addr_fifo.read()],
+                              m_nline[(addr_t) m_cmd_cas_addr_fifo.read()],
                               m_cmd_cas_srcid_fifo.read(),
                               m_cmd_cas_trdid_fifo.read(),
@@ -5399,8 +5797,8 @@
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".CAS_MISS_TRT_SET> Register a GET transaction in TRT" << std::hex
-                    << " / nline = " << m_nline[(vci_addr_t) m_cmd_cas_addr_fifo.read()]
+        if(m_debug)
+        {
+          std::cout << "  <MEMC " << name() << " CAS_MISS_TRT_SET> Register a GET transaction in TRT" << std::hex
+                    << " / nline = " << m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]
                     << " / trt_index = " << r_cas_trt_index.read() << std::endl;
         }
@@ -5417,12 +5815,12 @@
         r_cas_to_ixr_cmd_write      = false;
         r_cas_to_ixr_cmd_trdid      = r_cas_trt_index.read();
-        r_cas_to_ixr_cmd_nline      = m_nline[(vci_addr_t) m_cmd_cas_addr_fifo.read()];
+        r_cas_to_ixr_cmd_nline      = m_nline[(addr_t) m_cmd_cas_addr_fifo.read()];
         r_cas_fsm                   = CAS_WAIT;
 
 #if DEBUG_MEMC_CAS
-        if(m_debug_cas_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".CAS_MISS_XRAM_REQ> Request a GET transaction to IXR_CMD FSM" << std::hex
-                    << " / nline = " << m_nline[(vci_addr_t) m_cmd_cas_addr_fifo.read()]
+        if(m_debug)
+        {
+          std::cout << "  <MEMC " << name() << " CAS_MISS_XRAM_REQ> Request a GET transaction to IXR_CMD FSM" << std::hex
+                    << " / nline = " << m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]
                     << " / trt_index = " << r_cas_trt_index.read() << std::endl;
         }
@@ -5443,6 +5841,8 @@
   // the CLEANUP fsm.
   //
-  // It implements a round-robin priority between the four possible client FSMs
-  // XRAM_RSP, WRITE, CAS and CLEANUP. Each FSM can request the next services:
+  // It implements a round-robin priority between the five possible client FSMs
+  //     XRAM_RSP > CAS > CLEANUP > WRITE > CONFIG 
+  //
+  // Each FSM can request the next services:
   // - r_xram_rsp_to_cc_send_multi_req : multi-inval
   //   r_xram_rsp_to_cc_send_brdcast_req : broadcast-inval
@@ -5451,4 +5851,7 @@
   // - r_cas_to_cc_send_multi_req : multi-update
   //   r_cas_to_cc_send_brdcast_req : broadcast-inval
+  // - r_config_to_cc_send_multi_req : multi-inval
+  //   r_config_to_cc_send_brdcast_req : broadcast-inval
+  //   
   // - r_cleanup_to_cc_send_req : cleanup acknowledgement
   //
@@ -5464,8 +5867,9 @@
   switch(r_cc_send_fsm.read())
   {
-    case CC_SEND_WRITE_IDLE:
-      {
-        // XRAM_RSP FSM has highest priority
-        if(m_xram_rsp_to_cc_send_inst_fifo.rok() ||
+      /////////////////////////
+      case CC_SEND_CONFIG_IDLE:    // XRAM_RSP FSM has highest priority
+      {
+        // XRAM_RSP
+        if(m_xram_rsp_to_cc_send_inst_fifo.rok() or
             r_xram_rsp_to_cc_send_multi_req.read())
         {
@@ -5474,5 +5878,4 @@
           break;
         }
-
         if(r_xram_rsp_to_cc_send_brdcast_req.read())
         {
@@ -5481,6 +5884,6 @@
           break;
         }
-
-        if(m_cas_to_cc_send_inst_fifo.rok() ||
+        // CAS
+        if(m_cas_to_cc_send_inst_fifo.rok() or
             r_cas_to_cc_send_multi_req.read())
         {
@@ -5489,5 +5892,4 @@
           break;
         }
-
         if(r_cas_to_cc_send_brdcast_req.read())
         {
@@ -5496,5 +5898,5 @@
           break;
         }
-
+        // CLEANUP
         if (r_cleanup_to_cc_send_req.read())
         {
@@ -5502,6 +5904,6 @@
           break;
         }
-
-        if(m_write_to_cc_send_inst_fifo.rok() ||
+        // WRITE
+        if(m_write_to_cc_send_inst_fifo.rok() or
             r_write_to_cc_send_multi_req.read())
         {
@@ -5510,17 +5912,57 @@
           break;
         }
-
         if(r_write_to_cc_send_brdcast_req.read())
         {
           r_cc_send_fsm = CC_SEND_WRITE_BRDCAST_HEADER;
           m_cpt_inval++;
+          break;
+        }
+        // CONFIG
+        if(r_config_to_cc_send_multi_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        if(r_config_to_cc_send_brdcast_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CONFIG_BRDCAST_HEADER;
+          m_cpt_inval++;
+          break;
         }
         break;
       }
-
-    case CC_SEND_XRAM_RSP_IDLE:
-      {
-        // CAS FSM has highest priority
-        if(m_cas_to_cc_send_inst_fifo.rok() ||
+      ////////////////////////
+      case CC_SEND_WRITE_IDLE:     // CONFIG FSM has highest priority
+      {
+        // CONFIG
+        if(r_config_to_cc_send_multi_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        if(r_config_to_cc_send_brdcast_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CONFIG_BRDCAST_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        // XRAM_RSP
+        if(m_xram_rsp_to_cc_send_inst_fifo.rok() or
+            r_xram_rsp_to_cc_send_multi_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_XRAM_RSP_INVAL_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        if(r_xram_rsp_to_cc_send_brdcast_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_XRAM_RSP_BRDCAST_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        // CAS
+        if(m_cas_to_cc_send_inst_fifo.rok() or
             r_cas_to_cc_send_multi_req.read())
         {
@@ -5529,5 +5971,4 @@
           break;
         }
-
         if(r_cas_to_cc_send_brdcast_req.read())
         {
@@ -5536,12 +5977,12 @@
           break;
         }
-
-        if(r_cleanup_to_cc_send_req.read())
+        // CLEANUP
+        if (r_cleanup_to_cc_send_req.read())
         {
           r_cc_send_fsm = CC_SEND_CLEANUP_ACK;
           break;
         }
-
-        if(m_write_to_cc_send_inst_fifo.rok() ||
+        // WRITE
+        if(m_write_to_cc_send_inst_fifo.rok() or
             r_write_to_cc_send_multi_req.read())
         {
@@ -5550,5 +5991,4 @@
           break;
         }
-
         if(r_write_to_cc_send_brdcast_req.read())
         {
@@ -5557,6 +5997,59 @@
           break;
         }
-
-        if(m_xram_rsp_to_cc_send_inst_fifo.rok() ||
+        break;
+      }
+      ///////////////////////////
+      case CC_SEND_XRAM_RSP_IDLE:   // CAS FSM has highest priority
+      {
+        // CAS
+        if(m_cas_to_cc_send_inst_fifo.rok() or
+            r_cas_to_cc_send_multi_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CAS_UPDT_HEADER;
+          m_cpt_update++;
+          break;
+        }
+        if(r_cas_to_cc_send_brdcast_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CAS_BRDCAST_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        // CLEANUP
+        if(r_cleanup_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CLEANUP_ACK;
+          break;
+        }
+        // WRITE
+        if(m_write_to_cc_send_inst_fifo.rok() or
+            r_write_to_cc_send_multi_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_WRITE_UPDT_HEADER;
+          m_cpt_update++;
+          break;
+        }
+
+        if(r_write_to_cc_send_brdcast_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_WRITE_BRDCAST_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        // CONFIG
+        if(r_config_to_cc_send_multi_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        if(r_config_to_cc_send_brdcast_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CONFIG_BRDCAST_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        // XRAM_RSP
+        if(m_xram_rsp_to_cc_send_inst_fifo.rok() or
             r_xram_rsp_to_cc_send_multi_req.read())
         {
@@ -5565,17 +6058,15 @@
           break;
         }
-
         if(r_xram_rsp_to_cc_send_brdcast_req.read())
         {
           r_cc_send_fsm = CC_SEND_XRAM_RSP_BRDCAST_HEADER;
           m_cpt_inval++;
-        }
-
+          break;
+        }
         break;
       }
-
-    case CC_SEND_CAS_IDLE:
-      {
-        // CLEANUP FSM has highest priority
+      //////////////////////
+      case CC_SEND_CAS_IDLE:   // CLEANUP FSM has highest priority
+      {
         if(r_cleanup_to_cc_send_req.read())
         {
@@ -5583,6 +6074,5 @@
           break;
         }
-
-        if(m_write_to_cc_send_inst_fifo.rok() ||
+        if(m_write_to_cc_send_inst_fifo.rok() or
             r_write_to_cc_send_multi_req.read())
         {
@@ -5591,5 +6081,4 @@
           break;
         }
-
         if(r_write_to_cc_send_brdcast_req.read())
         {
@@ -5598,6 +6087,18 @@
           break;
         }
-
-        if(m_xram_rsp_to_cc_send_inst_fifo.rok() ||
+        // CONFIG
+        if(r_config_to_cc_send_multi_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        if(r_config_to_cc_send_brdcast_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CONFIG_BRDCAST_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        if(m_xram_rsp_to_cc_send_inst_fifo.rok() or
             r_xram_rsp_to_cc_send_multi_req.read())
         {
@@ -5606,5 +6107,4 @@
           break;
         }
-
         if(r_xram_rsp_to_cc_send_brdcast_req.read())
         {
@@ -5613,6 +6113,5 @@
           break;
         }
-
-        if(m_cas_to_cc_send_inst_fifo.rok() ||
+        if(m_cas_to_cc_send_inst_fifo.rok() or
             r_cas_to_cc_send_multi_req.read())
         {
@@ -5621,17 +6120,17 @@
           break;
         }
-
         if(r_cas_to_cc_send_brdcast_req.read())
         {
           r_cc_send_fsm = CC_SEND_CAS_BRDCAST_HEADER;
           m_cpt_inval++;
+          break;
         }
         break;
       }
-
-    case CC_SEND_CLEANUP_IDLE:
-      {
-        // WRITE FSM has highest priority
-        if(m_write_to_cc_send_inst_fifo.rok() ||
+      //////////////////////////
+      case CC_SEND_CLEANUP_IDLE:   // WRITE FSM has highest priority
+      {
+        // WRITE
+        if(m_write_to_cc_send_inst_fifo.rok() or
             r_write_to_cc_send_multi_req.read())
         {
@@ -5640,5 +6139,4 @@
           break;
         }
-
         if(r_write_to_cc_send_brdcast_req.read())
         {
@@ -5647,6 +6145,19 @@
           break;
         }
-
-        if(m_xram_rsp_to_cc_send_inst_fifo.rok() ||
+        // CONFIG
+        if(r_config_to_cc_send_multi_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        if(r_config_to_cc_send_brdcast_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_CONFIG_BRDCAST_HEADER;
+          m_cpt_inval++;
+          break;
+        }
+        // XRAM_RSP
+        if(m_xram_rsp_to_cc_send_inst_fifo.rok() or
             r_xram_rsp_to_cc_send_multi_req.read())
         {
@@ -5655,5 +6166,4 @@
           break;
         }
-
         if(r_xram_rsp_to_cc_send_brdcast_req.read())
         {
@@ -5662,6 +6172,6 @@
           break;
         }
-
-        if(m_cas_to_cc_send_inst_fifo.rok() ||
+        // CAS
+        if(m_cas_to_cc_send_inst_fifo.rok() or
             r_cas_to_cc_send_multi_req.read())
         {
@@ -5670,5 +6180,4 @@
           break;
         }
-
         if(r_cas_to_cc_send_brdcast_req.read())
         {
@@ -5677,16 +6186,67 @@
           break;
         }
-
+        // CLEANUP
         if(r_cleanup_to_cc_send_req.read())
         {
           r_cc_send_fsm = CC_SEND_CLEANUP_ACK;
-        }
-
+          break;
+        }
         break;
       }
-
-    case CC_SEND_CLEANUP_ACK:
-      {
-        // send only flit for a cleanup acknowledgement (from CLEANUP FSM)
+      /////////////////////////////////
+      case CC_SEND_CONFIG_INVAL_HEADER:   // send first flit multi-inval (from CONFIG FSM)
+      {
+        if(m_config_to_cc_send_inst_fifo.rok())
+        {
+          if(not p_dspin_out.read) break;
+          r_cc_send_fsm = CC_SEND_CONFIG_INVAL_NLINE;
+          break;
+        }
+        if(r_config_to_cc_send_multi_req.read()) r_config_to_cc_send_multi_req = false;
+        r_cc_send_fsm = CC_SEND_CONFIG_IDLE;
+        break;
+      }
+      ////////////////////////////////
+      case CC_SEND_CONFIG_INVAL_NLINE:    // send second flit multi-inval (from CONFIG FSM)
+      {
+        if(not p_dspin_out.read) break;
+        m_cpt_inval_mult++;
+        config_to_cc_send_fifo_get = true;
+        r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
+
+#if DEBUG_MEMC_CC_SEND
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CC_SEND_CONFIG_INVAL_NLINE> multi-inval for line "
+          << std::hex << r_config_to_cc_send_nline.read() << std::endl;
+#endif
+        break;
+      }
+      ///////////////////////////////////
+      case CC_SEND_CONFIG_BRDCAST_HEADER:   // send first flit BC-inval (from CONFIG FSM)
+      {
+        if(not p_dspin_out.read) break;
+        r_cc_send_fsm = CC_SEND_CONFIG_BRDCAST_NLINE;
+        break;
+      }
+      //////////////////////////////////
+      case CC_SEND_CONFIG_BRDCAST_NLINE:    // send second flit BC-inval (from CONFIG FSM)
+      {
+        if(not p_dspin_out.read) break;
+        m_cpt_inval_brdcast++;
+        r_config_to_cc_send_brdcast_req = false;
+        r_cc_send_fsm = CC_SEND_CONFIG_IDLE;
+
+#if DEBUG_MEMC_CC_SEND
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CC_SEND_CONFIG_BRDCAST_NLINE> BC-Inval for line "
+          << std::hex << r_config_to_cc_send_nline.read() << std::endl;
+#endif
+        break;
+      }
+      /////////////////////////
+      case CC_SEND_CLEANUP_ACK:   // send one flit for a cleanup acknowledgement 
+      {
         if(not p_dspin_out.read) break;
 
